******************************************************************************
* Project...........: Visual Extend 7.0
*                     Copyright (c) Devigus Engineering AG.
*                     All Rights Reserved.
*
* Program...........: VFXMAIN.PRG
* Author ...........: DEAG
* Created...........: September 2000
* Version...........: 07.00.000
*
* Description.......:
* Calling Samples...:
* Parameter List....:
* Major change list.:
*

#include "INCLUDE\VFX.H"

CLEAR ALL
CLEAR DLLS
CLEAR PROGRAM
CLEAR
CLOSE ALL

* Limit the memory occupied.
* This may be modified for your personal needs.
=SYS(3050,1,2048000)
=SYS(3050,2,2048000)
* Wait for locks in CDX and FPT-files like done with DBF files
=SYS(3052,1,.T.)
=SYS(3052,2,.T.)

* Enable SQL data enigne compatibility with VFP 7
=SYS(3099,70)

IF VERSION(2)=2
	SET ASSERT ON
ELSE
	CD (JUSTPATH(SYS(16)))
ENDIF

PUBLIC goenvironment,glclientsupport

glclientsupport=.F.
goenvironment = CREATEOBJECT("CEnvironment")

IF VARTYPE(goenvironment) # "O"

	IF VARTYPE(_VFP)="O"
		_VFP.VISIBLE = .T.
	ENDIF
	_SCREEN.WINDOWSTATE = 2

	RETURN .F.
ENDIF

goenvironment.SET()

PUBLIC govfptoolbar

govfptoolbar = CREATEOBJECT("CVFPToolBar")

LOCAL lcoldcaption, lcoldicon

lcoldcaption = _SCREEN.CAPTION
lcoldicon    = _SCREEN.ICON

PUBLIC __vfx_runtime

__vfx_runtime = .F.

IF ".EXE" $ UPPER(SYS(16)) OR ".APP" $ UPPER(SYS(16))
	__vfx_runtime = .T.

	SET SYSMENU TO

	_SCREEN.CAPTION = cap_application_title
	_SCREEN.ICON    = mainicon_loc
ENDIF

PUBLIC goprogram

goprogram = CREATEOBJECT("CApplication", cap_application_title)

IF VARTYPE(goprogram) = "O"
	RELEASE gcoldtalk, gcolddir, gcoldpath, gcoldclasslib, gcoldescape, gcoldresource

	#ifdef _debug_mode
		IF VERSION(2)=2
			goprogram.debugmode(.T.)
		ENDIF
	#ENDIF

	IF VARTYPE(_VFP)="O"
		_VFP.VISIBLE = .T.
	ENDIF

	goprogram.setlangid(id_language)

	IF goprogram.onuserlogin()
		*--prepare connection manager, if used, replace "conXY" with your connection name
		*goProgram.oConnMgr.setConnectionName("conXY")
		*--
		goprogram.START()
		goprogram.onuserlogout()
	ENDIF
ENDIF

RELEASE govfptoolbar
RELEASE goprogram
RELEASE goenvironment

CLOSE ALL

_SCREEN.CAPTION = lcoldcaption
_SCREEN.ICON    = lcoldicon

CLEAR ALL
CLEAR DLLS
CLEAR PROGRAM

RELEASE ALL EXTENDED
SET MESSAGE TO
* If started in VFP.exe reopen the project file.
IF VERSION(2)=2
	IF ADIR(laproj,"*.pjx")=1
		_SHELL="MODIFY PROJECT "+laproj[1,1]
	ENDIF
ENDIF
RETURN .T.

*****************************************************************************
**
DEFINE CLASS capplication AS cfoxapp
	***********************************************************
	**  User Settings
	cMainMenu=IIF(VERSION(5)>=700,"VFXMENU7.MPR","VFXMENU.MPR")	&& Main menu name including extension.
	ntoolbarspecialeffect=IIF(VERSION(5)>=700,2,0)	&& Coolbar-Style for VFP >=7

	cHelpFile = "VFX-Traders.CHM"

	** cMainMenu          = [Main Menu - Blank if none]
	** filemnuoffset 	  = 7	&& Offset within the file menu popup up to the first recently used form entry
	** winmnuoffset 	  = 1	&& Offset within the menu popup in the windows menu

	** cMainForm          = "VFXOPEN"	&& Specifies the name of the main form to be displayed when the application starts
	** cMainTitle         = [Main Title]	&& Specifies the main window caption
	** lcanclose 		  = .F.	&& Defines whether the main window can be closed using the close button or not
*lusedesktopcolor	  = .F.	&& 	Specifies if we use the windows desktop color as background for the main window

	cmainicon             = mainicon_loc
	cintrobitmap          = introform_loc	&& Bitmap to be used for the intro screen (also called splash screen)

	** cIntroForm         = [Class name used for the splash screen - Blank if none]
	** cLoginForm         = [SCX for login dialog if other]
	** lusewinusername	  = .T.	&& Specifies if VFX will retrieve the current Win 95, Win NT user in the application login procedure

	** lShowIntroForm     = .T. && if you want display the splash screen

	**	lcentury           = .T. && If you want use SET CENTURY ON

nshowgridordertype = 2	&& Specifies how the grid order should be showed: 0 - None, 1 - FontUnderline, 2 - Color
	**  nshowgridline 	   = .F.	&& Show grid lines. 0=use form setting, 1=yes in all forms, 2=no in all forms

	** cAscOrderRGB       = "RGB(255,255,0)"	&& Color to be used in the grid to highlight the column header for displaying "ascending" order
	** cDescOrderRGB      = "RGB(255,0,0)"		&& Color to be used in the grid to highlight the column header for displaying "descending" order

	nAskToSave = 1


	nAutoEditMode = 1


	** nUseEnterAsTab 	  = .F.	&& In ccheckbox enter moves the focus to the next object

	**	nHideWhenEmpty     = 1	&& Hide the edit pageframe when no records exist? 0 - None, 1 - .T., 2 - .F.

	nEnterIsEditInGrid = 2


	nEnableHook = 1


	**	nonsearchusegrid	=0	&& 0=use form setting, 1=use fields from grid in all forms, 2=use all fields in all forms

	**	nresizefont	=1	&& 0=use form setting, 1=.T. 2=.F.

	**	Enable OLE drag & drop on pages of a pageframe
	**	nPageOLEdragdrop=0	&& , 0 use form setting (default), 1 enable, 2 disable

	** lClearIDXMsg       = .F. && Don't show the 'Deleting Tmp. Index'
	** lDisableFormResize = .F. && Don't resize the forms
	** lAutoLogin         = .T. && Enables automatic login when the application starts
	** nAddUserToCaption  = 2   && Adds the username to the application caption: 0 - none, 1 - username, 2 - name

	************************************************************
	** CAppToolBar	- Tooolbar without Navigation Buttons
	** CAppNavBar	- Tooolbar with    Navigation Buttons
	cMainToolBar = "CAppNavBar"


	************************************************************
	** Database definitions

	cdatadir             = datapath_loc
	cmaindatabase        = database_loc

	cins_usr         = "INS_USR"	&& Name of the field in any table to be automatically used to store the "user" who inserted this record. If no such field exists, nothing happens
	cins_date		 = "INS_DATE"	&& Name of the field in any table to be automatically used to store the "date" when this record has been inserted. If no such field exists, nothing happens
	cedt_usr         = "EDT_USR"	&& Name of the field in any table to be automatically used to store the "user" who last modified this record. If no such field exists, nothing happens
	cedt_date		 = "EDT_DATE"	&& Name of the field in any table to be automatically used to store the "last edit" date. If no such field exists, nothing happens

	************************************************************
	** File to exclude int CDatabaseTools
	cexcludefiles        = "DBCXREG.DBF;CDBKMETA.DBF;SDTMETA.DBF;SDTUSER.DBF;COREMETA.DBF"

	** lRelogonQuit = .T.	&& .T. - quit the application, .F. - relogon last user.

	** Allow to delete child data in onetomany forms even if the deletion of parent records is not allowed.
	** lAllowDeleteChilddata = .T.

	**	See VFP help SET CENTURY TO for explanation!
	ncentury = 19	&& numeric value of the standard century.
	nrollover = 49	&& numeric value for the rollover clause.

	** Temporary Index files of type IDX:
	** By design, VFX clears IDX indexes when edit, insert or delete operations occur to prevent
	** VFP from crashing since IDX files cannot be open when transactions are used.
	** Usually the stored procedures use transactions, that's why VFX by design clears IDX
	** indexes before it continues with edit, insert or delete operations. If however you don't use
	** stored procedure logic in update, insert or delete triggers, you may like to avoid the deletion
	** of temporary IDX files whenever possible. The following properties allow you to do this:

	** lnoclearidxonedit 	= .t.	&& only if you don't use TRANSACTIONS in your referential integrity code
	** lnoclearidxoninsert = .t.	&& only if you don't use TRANSACTIONS in your referential integrity code
	** lnoclearidxondelete = .t.	&& only if you don't use TRANSACTIONS in your referential integrity code

	** luseActiveDesktop = .T.		&& set to .t. to use ActiveDesktop
	** luseAgent = .T.				&& set to .t. to use Agent Control

	** lremakeidxafterclear = .T.	&& set to .t. if you want auto recreation of idx files after clear

	** lsavedatabeforeupdate = .T.	&& Defines whether all data should be copied into a backup directory with generic name before a client site data update process starts

	**  lautorefreshonsave = .F.	&& When set to .t. all not yet visited pages will automatically be refreshed before the form valid event

	** ndonthidelistpage     = 1	&& Defines whether the list page should not be hidden when editing. 0 means "use form property ldonthidelistpage", 1 means .t. for all forms, and 2 means .f. for all forms

	PROCEDURE INIT
	LPARAMETERS tcmaintitle, tcmainmenu
	*this.oConnMgr = Createobject("cConnectionMgr")  && if you want to use the connection manager
	RETURN DODEFAULT(tcmaintitle, tcmainmenu)
ENDPROC

	PROCEDURE setlangid
	LPARAMETERS tclanguage

	DODEFAULT(tclanguage)

	DO CASE
	CASE tclanguage = "ENG"
		THIS.filemnuname = "File"
		THIS.winmnuname  = "Window"
		THIS.cdateformat = "AMERICAN"

	CASE tclanguage = "FRE"
		THIS.filemnuname = "Fichier"
		THIS.winmnuname  = "Fentre"
		THIS.cdateformat = "FRENCH"

	CASE tclanguage = "GER"
		THIS.filemnuname = "Datei"
		THIS.winmnuname  = "Fenster"
		THIS.cdateformat = "GERMAN"

	CASE tclanguage = "ITA"
		THIS.filemnuname = "File"
		THIS.winmnuname  = "Finestra"
		THIS.cdateformat = "ITALIAN"

	CASE tclanguage = "ESP"
		THIS.filemnuname = "Archivo"
		THIS.winmnuname  = "Ventana"
		THIS.cdateformat = "ITALIAN"

	CASE tclanguage = "USR"
		THIS.filemnuname = "File"
		THIS.winmnuname  = "Window"
		THIS.cdateformat = "AMERICAN"
	ENDCASE
ENDPROC


	PROCEDURE drawbackground

	IF THIS.luseactivedesktop
		** use the active desktop?
		IF TYPE("_screen.ad")#"O"
			_SCREEN.LOCKSCREEN=.T.
			_SCREEN.ADDOBJECT("ad","activedesktop")
			_SCREEN.ad.VISIBLE=.T.
			_SCREEN.LOCKSCREEN=.F.
		ENDIF
	ELSE
		IF VARTYPE(_SCREEN.ologoimage)<>"O"
			_SCREEN.ADDOBJECT("oLogoImage","image")
		ENDIF

		_SCREEN.ologoimage.PICTURE = desktop_loc

		_SCREEN.ologoimage.TOP  = (_SCREEN.HEIGHT - _SCREEN.ologoimage.HEIGHT)/2
		_SCREEN.ologoimage.LEFT = (_SCREEN.WIDTH  - _SCREEN.ologoimage.WIDTH)/2

		_SCREEN.ologoimage.VISIBLE = .T.
	ENDIF

	IF THIS.luseagent
		** use the agent class?
		LOCAL lcerror
		lcerror=ON("ERROR")
		ON ERROR *
		PUBLIC goagent
		goagent=CREATEOBJECT("cagent")
		ON ERROR &lcerror
		IF VARTYPE(goagent)="O"
			goagent.welcome()
		ENDIF
	ENDIF

ENDPROC

	FUNCTION opendatabase()
	LPARAMETERS tcexcl
	LOCAL lok
	#ifdef _dbcx
		IF !dbcx_init(THIS.cdatadir+"\"+THIS.cmaindatabase)
			RETURN .F.
		ENDIF
	#ELSE
		IF !ISNULL(THIS.cdatadir) AND !EMPTY(THIS.cdatadir)
			IF !vfx_checkupdate(THIS, .F., THIS.cupdatedir, THIS.cdatadir+"\")
				RETURN .F.
			ENDIF
		ENDIF
	#ENDIF

lok = DODEFAULT(m.tcexcl)

#ifdef _dbcx
IF lok
	PUBLIC ometa
	#ifdef _debug_mode
	IF VERSION(2)=2
     	ometa=CREATEOBJECT("MetaMgr",.T.,THIS.cdatadir+"\")	
		ometa.ldebugmode = .T.
	ELSE
		ometa=CREATEOBJECT("MetaMgr",.F.)
		ometa.ldebugmode = .F.
	ENDIF
#ELSE
	ometa=CREATEOBJECT("MetaMgr",.F.)
	ometa.ldebugmode = .F.
#ENDIF
ometa.setdatabase(DBC())
ENDIF
#ENDIF
RETURN lok
ENDFUNC

	PROCEDURE onquit()
	#ifdef _dbcx
	IF VARTYPE(ometa) == "O"
		RELEASE ometa
	ENDIF
#ENDIF

DODEFAULT()
ENDPROC

ENDDEFINE

***********************************************************
**  Class CEnvironment

DEFINE CLASS cenvironment AS CUSTOM
	PROTECTED colddir,coldpath,coldescape,coldclasslib,coldresource,;
		coldtalk, coldproc,noldmemo,coldmultilocks,colddeleted,;
		coldexclusive,coldnear,coldexact,coldconfirm,colddate,;
		coldshutdown,colderror, coldtitle, coldhelp,;
		nolddecimal, coldnotify, coldsafety, coldassert

	colddir      = FULLPATH(CURDIR())

	coldclasslib = SET('CLASSLIB')
	coldpath     = SET('PATH')
	coldresource = SET('RESOURCE')

	coldconfirm    = SET('CONFIRM')
	colddate       = SET('DATE')
	colddeleted    = SET('DELETED')
	coldescape     = SET('ESCAPE')
	coldexact      = SET('EXACT')
	coldexclusive  = SET('EXCLUSIVE')
	coldhelp       = SET('HELP',1)
	coldmultilocks = SET('MULTILOCKS')
	coldnear       = SET('NEAR')
	coldproc       = SET('PROCEDURE')
	coldtalk       = SET('TALK')
	noldmemo       = SET('MEMOWIDTH')

	colderror      = ON('ERROR')
	coldshutdown   = ON('SHUTDOWN')

	nolddecimal    = SET('DECIMAL')
	coldnotify     = SET('NOTIFY')
	coldsafety     = SET('SAFETY')
	coldassert     = SET('ASSERT')

	PROCEDURE INIT()
	LOCAL lcsys16,lcprogram

	lcsys16   = SYS(16)

	lcprogram = SUBSTR(lcsys16, AT("INIT", lcsys16)+5)

	IF !(".EXE" $ lcsys16 OR ".APP" $ lcsys16)
		CD LEFT(lcprogram,RAT("\",lcprogram)-8)
	ENDIF

	IF EMPTY(_vfx_homedir)
		#ifdef _dbcx
		SET PATH  TO lib, PROGRAM, INCLUDE, FORM, MENU, REPORT, HELP, lib\dbcx
	#ELSE
		SET PATH  TO lib, PROGRAM, INCLUDE, FORM, MENU, REPORT, HELP
	#ENDIF
ELSE
	LOCAL lcpath

	lcpath = _vfx_homedir+"\lib,"     +;
		_vfx_homedir+"\program," +;
		_vfx_homedir+"\include," +;
		_vfx_homedir+"\form,"    +;
		_vfx_homedir+"\menu,"    +;
		_vfx_homedir+"\report,"  +;
		_vfx_homedir+"\help"

	#ifdef _dbcx

	lcpath = _vfx_homedir+"\lib,"      +;
		_vfx_homedir+"\lib\dbcx," +;
		_vfx_homedir+"\program,"   +;
		_vfx_homedir+"\include,"   +;
		_vfx_homedir+"\form,"      +;
		_vfx_homedir+"\menu,"      +;
		_vfx_homedir+"\report,"    +;
		_vfx_homedir+"\help"

#ENDIF

SET PATH TO (lcpath)
ENDIF

SET PROCEDURE TO vfxfunc, vfxhook, applfunc
SET CLASSLIB  TO vfxappl, vfxobj, vfxform, vfxctrl, vfxrep, vfxfavor, vfxtools, vfxoffce, APPL

#ifdef _dbcx
SET PROCEDURE TO vfxdbcx  ADDITIVE
SET CLASSLIB  TO dbcxmgr  ADDITIVE
#ENDIF

*!* SDT: classlib settings for SDT 5.1.
#ifdef _stonefield
SET CLASSLIB  TO sdt  ADDITIVE
#ENDIF

IF VERSION(2)=2
	DELETE FILE vfxtemp.fky
	SAVE MACROS TO vfxtemp
	CLEAR MACRO
ENDIF

PUSH KEY CLEAR
ENDPROC

	PROCEDURE SET()
	SET COMPATIBLE OFF
	SET CONFIRM    ON
	SET DECIMAL    TO 2
	SET DELETED    ON
	SET ESCAPE     OFF
	SET EXACT      OFF
	SET EXCLUSIVE  OFF
	SET MEMOWIDTH  TO 256
	SET MULTILOCKS ON
	SET NEAR       OFF
	SET NOTIFY     OFF
	SET SAFETY     OFF
	SET TALK       OFF
	SET ASSERT	   ON
ENDPROC

	PROCEDURE RESET()
	LOCAL lccommand

	lccommand = THIS.coldescape
	SET ESCAPE &lccommand

	lccommand = THIS.coldresource
	SET RESOURCE &lccommand

	lccommand = THIS.coldconfirm
	SET CONFIRM &lccommand

	lccommand = THIS.colddate
	SET DATE TO &lccommand

	lccommand = THIS.colddeleted
	SET DELETED &lccommand

	lccommand = THIS.coldexact
	SET EXACT &lccommand

	lccommand = THIS.coldexclusive
	SET EXCLUSIVE &lccommand

	lccommand = THIS.coldmultilocks
	SET MULTILOCKS &lccommand

	lccommand = THIS.coldnear
	SET NEAR &lccommand

	lccommand = THIS.coldtalk
	SET TALK &lccommand

	SET MEMOWIDTH TO THIS.noldmemo

	CD (THIS.colddir)

	lccommand = THIS.coldclasslib

	IF LEN(lccommand) < 255
		SET CLASSLIB TO &lccommand
	ELSE
		SET CLASSLIB TO
	ENDIF

	lccommand = THIS.coldpath

	IF LEN(lccommand) < 255
		SET PATH TO &lccommand
	ELSE
		SET PATH TO
	ENDIF

	lccommand = THIS.coldproc

	IF LEN(lccommand) < 255
		SET PROCEDURE TO &lccommand
	ELSE
		SET PROCEDURE TO
	ENDIF

	SET DECIMAL TO THIS.nolddecimal

	lccommand = THIS.coldnotify
	SET NOTIFY &lccommand

	lccommand = THIS.coldsafety
	SET SAFETY &lccommand

	lccommand = THIS.coldassert
	SET ASSERT &lccommand

	IF VARTYPE(__vfx_runtime)="L" AND !__vfx_runtime
		lccommand = "'"+THIS.coldhelp+"'"
		SET HELP TO &lccommand
	ENDIF

	POP KEY ALL
ENDPROC

	PROCEDURE DESTROY()
	LOCAL lccommand

	THIS.RESET()

	lccommand = THIS.coldshutdown

	ON SHUTDOWN &lccommand

	IF VERSION(2)=2
		RESTORE MACROS FROM vfxtemp
	ENDIF

	lccommand = THIS.colderror

	ON ERROR &lccommand
ENDPROC

ENDDEFINE && CEnvironment
